# 合并两个有序数组——数组、双指针、排序——这题的题解绝了

> 发布于：2022-03-04 | 分类：刷题 | 原文：https://www.imbailey.cn/post/leetcode-88-merge-sorted-array-two-pointers

## 题目

> 该题来自：https://leetcode-cn.com/problems/merge-sorted-array/

#### [88. 合并两个有序数组](https://leetcode-cn.com/problems/merge-sorted-array/)

难度简单1308收藏分享切换为英文接收动态反馈

给你两个按 **非递减顺序** 排列的整数数组 `nums1` 和 `nums2`，另有两个整数 `m` 和 `n` ，分别表示 `nums1` 和 `nums2` 中的元素数目。

请你 **合并** `nums2` 到 `nums1` 中，使合并后的数组同样按 **非递减顺序** 排列。

**注意：**最终，合并后数组不应由函数返回，而是存储在数组 `nums1` 中。为了应对这种情况，`nums1` 的初始长度为 `m + n`，其中前 `m` 个元素表示应合并的元素，后 `n` 个元素为 `0` ，应忽略。`nums2` 的长度为 `n` 。

 

**示例 1：**

```
输入：nums1 = [1,2,3,0,0,0], m = 3, nums2 = [2,5,6], n = 3
输出：[1,2,2,3,5,6]
解释：需要合并 [1,2,3] 和 [2,5,6] 。
合并结果是 [1,2,2,3,5,6] ，其中斜体加粗标注的为 nums1 中的元素。
```

**示例 2：**

```
输入：nums1 = [1], m = 1, nums2 = [], n = 0
输出：[1]
解释：需要合并 [1] 和 [] 。
合并结果是 [1] 。
```

**示例 3：**

```
输入：nums1 = [0], m = 0, nums2 = [1], n = 1
输出：[1]
解释：需要合并的数组是 [] 和 [1] 。
合并结果是 [1] 。
注意，因为 m = 0 ，所以 nums1 中没有元素。nums1 中仅存的 0 仅仅是为了确保合并结果可以顺利存放到 nums1 中。
```

 

**提示：**

- `nums1.length == m + n`
- `nums2.length == n`
- `0 <= m, n <= 200`
- `1 <= m + n <= 200`
- `-109 <= nums1[i], nums2[j] <= 109`



## 题解

**法一：直接合并后用sort()排序**

本来以为会禁用STL，但是竟然没有，这种方法能过也是出乎我的意料。代码：

```c++
class Solution {
public:
    void merge(vector<int>& nums1, int m, vector<int>& nums2, int n) {
        for(int i=m;i<m+n;i++){
            nums1[i] = nums2[i-m];
        }
        sort(nums1.begin(),nums1.end());

    }
};
```

而且还超过了百分之百的用户，笑死，赶紧截图纪念。

![leetcode代码提交结果](https://myblog-1257298572.cos.ap-shanghai.myqcloud.com/mypic/img/leetcode%E4%BB%A3%E7%A0%81%E6%8F%90%E4%BA%A4%E7%BB%93%E6%9E%9C.png)

sort()函数可以套用快速排序的时间复杂度和空间复杂度，都为O((m+n)log(m+n))。



**法二：双指针**

利用一个重要性质：nums1和nums2都是有序数组。

用两个指针p1和p2分别指向nums1和num2的头部，然后比较nums[p1]和nums[p2]，将较小的那个数的指针（比如p1）往后移（p1++）。有点像归并排序。

这个图非常生动形象：

![gif1](https://myblog-1257298572.cos.ap-shanghai.myqcloud.com/mypic/img/1.gif)

代码：

```c++
class Solution {
public:
    void merge(vector<int>& nums1, int m, vector<int>& nums2, int n) {
        int p1 = 0, p2 = 0;
        int sorted[m + n];
        int cur;
        while (p1 < m || p2 < n) {
            if (p1 == m) {
                cur = nums2[p2++];
            } else if (p2 == n) {
                cur = nums1[p1++];
            } else if (nums1[p1] < nums2[p2]) {
                cur = nums1[p1++];
            } else {
                cur = nums2[p2++];
            }
            sorted[p1 + p2 - 1] = cur;
        }
        for (int i = 0; i != m + n; ++i) {
            nums1[i] = sorted[i];
        }
    }
};

作者：LeetCode-Solution
链接：https://leetcode-cn.com/problems/merge-sorted-array/solution/he-bing-liang-ge-you-xu-shu-zu-by-leetco-rrb0/
来源：力扣（LeetCode）
著作权归作者所有。商业转载请联系作者获得授权，非商业转载请注明出处。
```

两指针最多移动m+n次，因此时间复杂度O(m+n)。为防止覆盖，需要新建m+n长度的数组，因此空间复杂度为O(m+n)。



**法三：逆向双指针**

怎么样不建立新的数组，直接利用nums1后面空余的部分呢？我们想到了让p1和p2两指针从后向前遍历，每次取最大的那个数放在nums1的最后面。

但是有一个前提，在从后向前填的过程中会不会覆盖nums1前面的数字呢？答案是不会，下面证明：

在遍历的任一时刻，`nums1`数组中有`m-p1-1`个元素被放入`nums1`的最后面，`nums2`数组中有`n-p2-1`个元素被放入`nums1`的最后面。而在指针p1的后面，`nums1`数组有`m+n-p1-1`个位置。

由于

$$ m+n-p1-1 >= m-p1-1+n-p2-1 $$

等价于

$$ p2>-1 $$

永远成立。所以不会被覆盖。

代码：

```c++
class Solution {
public:
    void merge(vector<int>& nums1, int m, vector<int>& nums2, int n) {
        int p1 = m - 1, p2 = n - 1;
        int tail = m + n - 1;
        int cur;
        while (p1 >= 0 || p2 >= 0) {
            if (p1 == -1) {
                cur = nums2[p2--];
            } else if (p2 == -1) {
                cur = nums1[p1--];
            } else if (nums1[p1] > nums2[p2]) {
                cur = nums1[p1--];
            } else {
                cur = nums2[p2--];
            }
            nums1[tail--] = cur;
        }
    }
};

作者：LeetCode-Solution
链接：https://leetcode-cn.com/problems/merge-sorted-array/solution/he-bing-liang-ge-you-xu-shu-zu-by-leetco-rrb0/
来源：力扣（LeetCode）
著作权归作者所有。商业转载请联系作者获得授权，非商业转载请注明出处。
```

看完这个题解我真是觉得太牛逼了。

时间复杂度O(m+n)，因为不需要额外数组，所以空间复杂度O(1)。
